xref: /haiku/configure (revision d73993ff202c77741d8591feee6566f6e342c0fe)
152a38012Sejakowatz#!/bin/sh
252a38012Sejakowatz#
3338b8dc3SIngo Weinhold# configure [ <options> ]
4614026d7Sshatty
5022fa244SIngo Weinhold# usage
6022fa244SIngo Weinhold#
7022fa244SIngo Weinhold# Prints usage.
8022fa244SIngo Weinhold#
9022fa244SIngo Weinholdusage()
10022fa244SIngo Weinhold{
11022fa244SIngo Weinhold	cat << EOF
12022fa244SIngo Weinhold
13022fa244SIngo WeinholdUsage: $0 <options>
14022fa244SIngo Weinholdoptions:
15e173a1ecSIngo Weinhold  --bootstrap <haikuporter> <HaikuPorts cross repo> <HaikuPorts repo>
16e173a1ecSIngo Weinhold                              Prepare for a bootstrap build. No pre-built
17e173a1ecSIngo Weinhold                              packages will be used, instead they will be built
18e173a1ecSIngo Weinhold                              from the sources (in several phases).
19e173a1ecSIngo Weinhold                              <haikuporter> is the path to the haikuporter tool
20e173a1ecSIngo Weinhold                              suitable for the host platform.
21e173a1ecSIngo Weinhold                              <HaikuPorts cross repo> is the path to a checked
22e173a1ecSIngo Weinhold                              out HaikuPorts cross-compilation repository.
23e173a1ecSIngo Weinhold                              <HaikuPorts repo> is the path to a checked out
24e173a1ecSIngo Weinhold                              HaikuPorts repository.
25c0e8cc1aSIngo Weinhold  --build-cross-tools <arch> [ <build tools dir> ]
26338b8dc3SIngo Weinhold                              Assume cross compilation. <build tools dir>
27338b8dc3SIngo Weinhold                              defines the location of the build tools sources.
28338b8dc3SIngo Weinhold                              They will be compiled and placed in the output
29a5b60fa8SOliver Tappe                              directory under "cross-tools". The HAIKU_* tools
30a5b60fa8SOliver Tappe                              variables will be set accordingly.
3120ab75e6SIngo Weinhold                              <arch> specifies the target architecture, either
321b38c341SAlexander von Gluck IV                              "x86_gcc2", "x86", "x86_64", "ppc", "m68k", "arm"
33c0e8cc1aSIngo Weinhold                              This option and --cross-tools-prefix can be
34c0e8cc1aSIngo Weinhold                              specified multiple times. The first cross tools
35c0e8cc1aSIngo Weinhold                              specify the primary tools, the subsequent ones the
36c0e8cc1aSIngo Weinhold                              secondary tools (for "hybrid" images).
37c0e8cc1aSIngo Weinhold                              For the first --build-cross-tools the
38c0e8cc1aSIngo Weinhold                              <build tools dir> argument must be specified and
39c0e8cc1aSIngo Weinhold                              for the subsequent ones it must be omitted.
40eccc7665SIngo Weinhold  --cross-tools-prefix <prefix>
41eccc7665SIngo Weinhold                              Assume cross compilation. <prefix> should be a
42eccc7665SIngo Weinhold                              path to the directory where the cross
43eccc7665SIngo Weinhold                              compilation tools are located, plus the platform
440da9c208SIngo Weinhold                              prefix, e.g. "/path/to/tools/i586-pc-haiku-".
45eccc7665SIngo Weinhold                              This overrides the HAIKU_* tool variables.
46a66c32ddSIngo Weinhold  --distro-compatibility <level>
47a66c32ddSIngo Weinhold                              The distribution's level of compatibility with
48a66c32ddSIngo Weinhold                              the official Haiku distribution. The generated
49a66c32ddSIngo Weinhold                              files will contain the respective trademarks
50a66c32ddSIngo Weinhold                              accordingly.
51a66c32ddSIngo Weinhold                              official -- the official Haiku distribution.
52a66c32ddSIngo Weinhold                              compatible -- a Haiku Compatible (tm) distro.
53a66c32ddSIngo Weinhold                              default -- any other distro (default value).
5460d8d8fcSIngo Weinhold  --enable-multiuser          Enable experimental multiuser support.
55eccc7665SIngo Weinhold  --help                      Prints out this help.
562ebcd86dSIngo Weinhold  --host-only                 Configure for building tools for the build host
572ebcd86dSIngo Weinhold                              only. Haiku cannot be built when configured like
582ebcd86dSIngo Weinhold                              this.
5967838392SAxel Dörfler  --include-patented-code     Enable code that is known to implemented patented
6067838392SAxel Dörfler                              ideas and techniques. If this option is not
6167838392SAxel Dörfler                              specified, the resulting distribution may still
6267838392SAxel Dörfler                              implement patented ideas and techniques. This
6367838392SAxel Dörfler                              option only disables code that is currently known
6467838392SAxel Dörfler                              to be problematic.
6576fa0be3SIngo Weinhold  --include-sources           Includes the source code of projects that require
6676fa0be3SIngo Weinhold                              either an offer of source code or a copy of the
6776fa0be3SIngo Weinhold                              patched sources. This is preferable when
6876fa0be3SIngo Weinhold                              distributing on physical mediums.
691974210fSFrançois Revol  --include-3rdparty          Include 3rdparty/ in the build system.
704880ae01SJessica Hamilton  -j<n>                       Only relevant for --build-cross-tools. Is passed
714880ae01SJessica Hamilton                              on to the make building the build tools.
72aa2e5ecaSOliver Tappe  --no-downloads              Do not download anything. Useful when trying to
73aa2e5ecaSOliver Tappe                              bootstrap and build Haiku from source only.
747c4641d0SOliver Tappe  --target=TARGET             Select build target platform.
757c4641d0SOliver Tappe                              [default=${TARGET_PLATFORM}]
76deb1a319SAlexander von Gluck IV                              valid targets=r5,bone,dano,haiku
77483b28e4SIngo Weinhold  --target-arch <arch>        Haiku only: Specify the target architecture to
78483b28e4SIngo Weinhold                              build for. Must be one of the architectures of the
79483b28e4SIngo Weinhold                              host system. The installed build tools for that
80483b28e4SIngo Weinhold                              architecture will be used.
81483b28e4SIngo Weinhold                              This option can be specified multiple times. The
82483b28e4SIngo Weinhold                              first occurrence specifies the primary
83483b28e4SIngo Weinhold                              architecture of the Haiku to build, subsequent
84483b28e4SIngo Weinhold                              ones the secondary architectures.
85961fc581SFrançois Revol  --update                    re-runs last configure invocation [must be given
867c4641d0SOliver Tappe                              as first option!]
87*d73993ffSAugustin Cavalier  --use-clang <arch>          Build with host Clang instead of GCC cross
88*d73993ffSAugustin Cavalier                              compiler, targeting <arch>
89eccc7665SIngo Weinhold  --use-gcc-pipe              Build with GCC option -pipe. Speeds up the build
905a34a443SFrançois Revol                              process, but uses more memory.
91ed38d2efSJerome Duval  --use-gcc-graphite          Build with GCC Graphite engine for loop
92ed38d2efSJerome Duval                              optimizations. Only for gcc 4.
930385b065SIngo Weinhold  --use-32bit                 Use -m32 flag on 64bit host gcc compiler.
94bc96e8f3SIngo Weinhold  --use-xattr                 Use Linux xattr respectively *BSD extattr support
95bc96e8f3SIngo Weinhold                              for BeOS attribute emulation. Warning: Make sure
96bc96e8f3SIngo Weinhold                              your file system supports sufficient attribute
97bc96e8f3SIngo Weinhold                              sizes (4 KB per file for all attributes won't
98bc96e8f3SIngo Weinhold                              suffice).
99bc96e8f3SIngo Weinhold  --use-xattr-ref             Use the generic BeOS attribute emulation, but use
100bc96e8f3SIngo Weinhold                              Linux xattr respectively *BSD extattr support to
101bc96e8f3SIngo Weinhold                              make it more robust (i.e. attribute mix-ups become
102bc96e8f3SIngo Weinhold                              less likely).
1034da6cf84SFrançois Revol  --with-gdb <gdb sources dir>
1044da6cf84SFrançois Revol                              specify the path to a GDB source dir, to build
1054da6cf84SFrançois Revol                              GDB for each arch we build the cross-tools for.
106338b8dc3SIngo Weinhold
107338b8dc3SIngo Weinholdenvironment variables:
10863701e7dSOliver Tappe  CC                          The host compiler. Defaults to "gcc".
109c0e8cc1aSIngo Weinhold  HAIKU_AR_x86_gcc2           The static library archiver for x86_gcc2.
110c0e8cc1aSIngo Weinhold                              Defaults to "ar".
111c0e8cc1aSIngo Weinhold  HAIKU_CC_x86_gcc2           The x86_gcc2 compiler. Defaults to "gcc".
112c0e8cc1aSIngo Weinhold  HAIKU_LD_x86_gcc2           The x86_gcc2 linker. Defaults to "ld".
113c0e8cc1aSIngo Weinhold  HAIKU_OBJCOPY_x86_gcc2      The x86_gcc2 objcopy to be used. Defaults to
114c0e8cc1aSIngo Weinhold                              "objcopy".
115c0e8cc1aSIngo Weinhold  HAIKU_RANLIB_x86_gcc2       The static library indexer for x86_gcc2. Defaults
116c0e8cc1aSIngo Weinhold                              to "ranlib".
117c0e8cc1aSIngo Weinhold  HAIKU_STRIP_x86_gcc2        The x86_gcc2 strip command. Defaults to "strip".
118a04a520bSJonathan Schleifer  HAIKU_NASM                  The nasm assembler (x86 and x86_64 only).
119c0e8cc1aSIngo Weinhold  HAIKU_CPPFLAGS_<arch>       The preprocessor flags for target architecture
120c0e8cc1aSIngo Weinhold                              <arch>. Defaults to "".
121c0e8cc1aSIngo Weinhold  HAIKU_CCFLAGS_<arch>        The C flags for target architecture <arch>.
122c0e8cc1aSIngo Weinhold                              Defaults to "".
123c0e8cc1aSIngo Weinhold  HAIKU_CXXFLAGS_<arch>       The C++ flags for target architecture <arch>.
124c0e8cc1aSIngo Weinhold                              Defaults to "".
125c0e8cc1aSIngo Weinhold  HAIKU_LDFLAGS_<arch>        The linker flags for target architecture <arch>.
126c0e8cc1aSIngo Weinhold                              Defaults to "".
127c0e8cc1aSIngo Weinhold  HAIKU_ARFLAGS_<arch>        The flags passed to HAIKU_AR for target
128c0e8cc1aSIngo Weinhold                              architecture <arch> for archiving. Defaults to
129c0e8cc1aSIngo Weinhold                              "cru".
130c0e8cc1aSIngo Weinhold  HAIKU_UNARFLAGS_<arch>      The flags passed to HAIKU_AR for target
131c0e8cc1aSIngo Weinhold                              architecture <arch> for unarchiving. Defaults to
132c0e8cc1aSIngo Weinhold                              "x".
13364f6da31SIngo Weinhold
134c0e8cc1aSIngo WeinholdNon-default output directories:
13564f6da31SIngo Weinhold  By default all objects, build configuration, and other related files are
13664f6da31SIngo Weinhold  stored in /path/to/haiku_source/generated.  To store objects in a non-default
13764f6da31SIngo Weinhold  location, run "../../relative/path/to/haiku_source/configure <options>" from
13864f6da31SIngo Weinhold  within your non-default location.  "jam [ options ] targets" can then be run
13964f6da31SIngo Weinhold  directly inside your non-default location.  Another option is to invoke "jam
14064f6da31SIngo Weinhold  [ options ] targets" from within haiku_source.  This can be accomplished by
14164f6da31SIngo Weinhold  either "export HAIKU_OUTPUT_DIR=your non-default location" before invoking
14264f6da31SIngo Weinhold  jam or by creating a symlink of haiku_source/generated pointing to your
14364f6da31SIngo Weinhold  non-default location and running jam.
14464f6da31SIngo Weinhold
14564f6da31SIngo Weinhold
146022fa244SIngo WeinholdEOF
147022fa244SIngo Weinhold}
148022fa244SIngo Weinhold
149022fa244SIngo Weinhold# assertparam
150022fa244SIngo Weinhold#
151022fa244SIngo Weinhold# Checks whether at least one parameter is left.
152022fa244SIngo Weinhold#
153022fa244SIngo Weinholdassertparam()
154022fa244SIngo Weinhold{
15520ab75e6SIngo Weinhold	if [ $2 -lt 2 ]; then
156022fa244SIngo Weinhold		echo $0: \`$1\': Parameter expected.
157022fa244SIngo Weinhold		exit 1
158022fa244SIngo Weinhold	fi
159022fa244SIngo Weinhold}
160022fa244SIngo Weinhold
16120ab75e6SIngo Weinhold# assertparams
16220ab75e6SIngo Weinhold#
16320ab75e6SIngo Weinhold# Checks whether at least a certain number of parameters is left.
16420ab75e6SIngo Weinhold#
16520ab75e6SIngo Weinholdassertparams()
16620ab75e6SIngo Weinhold{
16720ab75e6SIngo Weinhold	if [ $3 -le $2 ]; then
16820ab75e6SIngo Weinhold		echo $0: \`$1\': Not enough parameters.
16920ab75e6SIngo Weinhold		exit 1
17020ab75e6SIngo Weinhold	fi
17120ab75e6SIngo Weinhold}
17220ab75e6SIngo Weinhold
173e173a1ecSIngo Weinhold# absolute_path
174e173a1ecSIngo Weinhold#
175e173a1ecSIngo Weinhold# returns the absolute path of a given path.
176e173a1ecSIngo Weinhold#
177e173a1ecSIngo Weinholdabsolute_path()
178e173a1ecSIngo Weinhold{
1796a4f3954SFrançois Revol	if [ "x$1" != "x${1#/}" ]; then
180e173a1ecSIngo Weinhold		echo "$1"
181e173a1ecSIngo Weinhold	else
182e173a1ecSIngo Weinhold		echo "`pwd`/$1"
183e173a1ecSIngo Weinhold	fi
184e173a1ecSIngo Weinhold}
185e173a1ecSIngo Weinhold
18639d444a3SArvind S Raj# check_dir_exists
18739d444a3SArvind S Raj#
18839d444a3SArvind S Raj# check if a directory exists or not
18939d444a3SArvind S Raj#
19039d444a3SArvind S Rajcheck_dir_exists()
19139d444a3SArvind S Raj{
19239d444a3SArvind S Raj	if [ -d "$1" ]; then
19339d444a3SArvind S Raj		return 0
19439d444a3SArvind S Raj	else
19539d444a3SArvind S Raj		return 1
19639d444a3SArvind S Raj	fi
19739d444a3SArvind S Raj}
19839d444a3SArvind S Raj
199502882dbSJessica Hamilton# check_file_exists
200502882dbSJessica Hamilton#
201502882dbSJessica Hamilton# check if a file exists or not
202502882dbSJessica Hamilton#
203502882dbSJessica Hamiltoncheck_file_exists()
204502882dbSJessica Hamilton{
205502882dbSJessica Hamilton	if [ -f "$1" ]; then
206502882dbSJessica Hamilton		return 0
207502882dbSJessica Hamilton	else
208502882dbSJessica Hamilton		return 1
209502882dbSJessica Hamilton	fi
210502882dbSJessica Hamilton}
211502882dbSJessica Hamilton
2129a001156SOliver Tappe# real_path
2139a001156SOliver Tappe#
2149a001156SOliver Tappe# returns the realpath of a symbolic link.
2159a001156SOliver Tappe#
2169a001156SOliver Tappereal_path()
2179a001156SOliver Tappe{
2189a001156SOliver Tappe	perl -MCwd=realpath -e'print realpath($ARGV[0]), "\n"' "$1"
2199a001156SOliver Tappe}
2209a001156SOliver Tappe
22109c5682dSIngo Weinhold# standard_gcc_settings
22209c5682dSIngo Weinhold#
22309c5682dSIngo Weinhold# Sets the variables for a GCC platform.
22409c5682dSIngo Weinhold#
22509c5682dSIngo Weinholdstandard_gcc_settings()
22609c5682dSIngo Weinhold{
227c0e8cc1aSIngo Weinhold	local gcc=$1
228c0e8cc1aSIngo Weinhold
229138f5fb4SIngo Weinhold	if which greadlink > /dev/null 2>&1; then
230b29b48b1SMatt Madia		readlink="greadlink -e"
231138f5fb4SIngo Weinhold	elif which realpath > /dev/null 2>&1; then
232b29b48b1SMatt Madia		readlink=realpath
2339a001156SOliver Tappe	elif readlink -e / > /dev/null 2>&1; then
234b29b48b1SMatt Madia		readlink="readlink -e"
2359a001156SOliver Tappe	else
2369a001156SOliver Tappe		readlink=real_path
237b4b6d83cSMatt Madia	fi
238138f5fb4SIngo Weinhold
23909c5682dSIngo Weinhold	# PLATFORM_LINKLIBS
240c0e8cc1aSIngo Weinhold	local gcclib=`$gcc -print-libgcc-file-name`
241c0e8cc1aSIngo Weinhold	local gccdir=`dirname ${gcclib}`
2425b0f7b1bSOliver Tappe
243c0e8cc1aSIngo Weinhold	local gccRawVersion=`$gcc -dumpversion`
244c0e8cc1aSIngo Weinhold	local gccMachine=`$gcc -dumpmachine`
245338b8dc3SIngo Weinhold
246fc8967f1SIngo Weinhold	# determine architecture from machine triple
247c0e8cc1aSIngo Weinhold	case $gccMachine in
248c0e8cc1aSIngo Weinhold		arm-*)		targetCpu=arm;;
249c0e8cc1aSIngo Weinhold		i?86-*)		targetCpu=x86;;
250c0e8cc1aSIngo Weinhold		m68k-*)		targetCpu=m68k;;
251c0e8cc1aSIngo Weinhold		powerpc-*)	targetCpu=ppc;;
252c0e8cc1aSIngo Weinhold		x86_64-*)	targetCpu=x86_64;;
253fc8967f1SIngo Weinhold		*)
254c0e8cc1aSIngo Weinhold			echo "Unsupported gcc target machine: $gccMachine" >&2
255fc8967f1SIngo Weinhold			exit 1
256fc8967f1SIngo Weinhold			;;
257fc8967f1SIngo Weinhold	esac
258fc8967f1SIngo Weinhold
259c0e8cc1aSIngo Weinhold	local targetArch=$targetCpu
260fc8967f1SIngo Weinhold
261c0e8cc1aSIngo Weinhold	case $gccRawVersion in
2626cc8eecfSOliver Tappe		2.9*)
2635b0f7b1bSOliver Tappe			# check for correct (most up-to-date) legacy compiler and complain
2645b0f7b1bSOliver Tappe			# if an older one is installed
265c0e8cc1aSIngo Weinhold			if [ $gccRawVersion != $haikuRequiredLegacyGCCVersion ]; then
2665b0f7b1bSOliver Tappe				echo "GCC version $haikuRequiredLegacyGCCVersion is required!";
2675b0f7b1bSOliver Tappe				echo "Please download it from www.haiku-os.org...";
2685b0f7b1bSOliver Tappe				exit 1;
2695b0f7b1bSOliver Tappe			fi
270aaeadfcbSAlex Smith
271c0e8cc1aSIngo Weinhold			targetArch=x86_gcc2
2725b0f7b1bSOliver Tappe			;;
2738b5934c9SIngo Weinhold	esac
27465ad1ba3SAlex Smith
275c0e8cc1aSIngo Weinhold	local bootLibgcc
276c0e8cc1aSIngo Weinhold	local bootLibSupCxx
27766a7f29fSJérôme Duval	local bootCxxHeaders
278c0e8cc1aSIngo Weinhold	case $gccMachine in
2794591ebc9SAlex Smith		x86_64-*)
28066a7f29fSJérôme Duval			# Boot loader is 32-bit, need the 32-bit libs and c++ config
28111ae3c5fSOliver Tappe			bootLibgcc=`$gcc -m32 -print-file-name=libgcc.a`
282c0e8cc1aSIngo Weinhold			bootLibSupCxx=`$gcc -m32 -print-file-name=libsupc++.a`
28366a7f29fSJérôme Duval
28466a7f29fSJérôme Duval			local headersBase=$gccdir/../../../..
28566a7f29fSJérôme Duval			local headers=$headersBase/$gccMachine/include/c++/$gccRawVersion
28666a7f29fSJérôme Duval			if [ ! -d $headers ]; then
28766a7f29fSJérôme Duval				headers=$headersBase/include/c++/$gccRawVersion
28866a7f29fSJérôme Duval			fi
28966a7f29fSJérôme Duval			bootCxxHeaders="$headers/$gccMachine/32"
2904591ebc9SAlex Smith			;;
291338b8dc3SIngo Weinhold	esac
292c0e8cc1aSIngo Weinhold
293c0e8cc1aSIngo Weinhold	# determine whether graphite loop optimization should/can be used
294c0e8cc1aSIngo Weinhold	local useGraphite=`get_variable HAIKU_USE_GCC_GRAPHITE_$targetCpu`
295c0e8cc1aSIngo Weinhold	if [ -z "$useGraphite" ]; then
296c0e8cc1aSIngo Weinhold		useGraphite=$useGccGraphiteDefault
297c0e8cc1aSIngo Weinhold	fi
298c0e8cc1aSIngo Weinhold
299c0e8cc1aSIngo Weinhold	if [ "$useGraphite" != 0 ]; then
300c0e8cc1aSIngo Weinhold		UNUSED=`echo "int main() {}" | $gcc -xc -c -floop-block - 2>&1`
301c0e8cc1aSIngo Weinhold		if [ $? != 0 ]; then
302c0e8cc1aSIngo Weinhold			echo "GCC Graphite loop optimizations cannot be used on $targetArch"
303c0e8cc1aSIngo Weinhold			useGraphite=0
304c0e8cc1aSIngo Weinhold		fi
305c0e8cc1aSIngo Weinhold	fi
306c0e8cc1aSIngo Weinhold
307c0e8cc1aSIngo Weinhold	set_variable HAIKU_CPU_$targetArch $targetCpu
308c0e8cc1aSIngo Weinhold
309c0e8cc1aSIngo Weinhold	get_build_tool_path CC_$targetArch "$gcc"
310a7bddff1SJonathan Schleifer	set_variable HAIKU_CC_IS_CLANG_$targetArch $useClang
311c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_RAW_VERSION_$targetArch $gccRawVersion
312c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_MACHINE_$targetArch $gccMachine
313c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_LIB_DIR_$targetArch $gccdir
31466a7f29fSJérôme Duval	set_variable HAIKU_BOOT_CXX_HEADERS_DIR_$targetArch "$bootCxxHeaders"
31511ae3c5fSOliver Tappe	set_variable HAIKU_BOOT_LIBSUPCXX_$targetArch "$bootLibSupCxx"
31611ae3c5fSOliver Tappe	set_variable HAIKU_BOOT_LIBGCC_$targetArch $bootLibgcc
317c0e8cc1aSIngo Weinhold	set_variable HAIKU_USE_GCC_GRAPHITE_$targetArch $useGraphite
318c0e8cc1aSIngo Weinhold
319c0e8cc1aSIngo Weinhold	standard_gcc_settings_targetArch=$targetArch
320c0e8cc1aSIngo Weinhold}
321c0e8cc1aSIngo Weinhold
322c0e8cc1aSIngo Weinhold# set_variable
323c0e8cc1aSIngo Weinhold#
324c0e8cc1aSIngo Weinhold# Set the value of a variable.
325c0e8cc1aSIngo Weinhold#
326c0e8cc1aSIngo Weinholdset_variable()
327c0e8cc1aSIngo Weinhold{
328c0e8cc1aSIngo Weinhold	eval "$1=\"$2\""
329c0e8cc1aSIngo Weinhold}
330c0e8cc1aSIngo Weinhold
331c0e8cc1aSIngo Weinhold# get_variable
332c0e8cc1aSIngo Weinhold#
333c0e8cc1aSIngo Weinhold# Echo the value of a variable.
334c0e8cc1aSIngo Weinhold#
335c0e8cc1aSIngo Weinholdget_variable()
336c0e8cc1aSIngo Weinhold{
337c0e8cc1aSIngo Weinhold	eval "echo \${$1}"
33809c5682dSIngo Weinhold}
33909c5682dSIngo Weinhold
340338b8dc3SIngo Weinhold# set_default_value
341338b8dc3SIngo Weinhold#
342338b8dc3SIngo Weinhold# Set the value for a variable, if no value is set yet.
343338b8dc3SIngo Weinhold#
344338b8dc3SIngo Weinholdset_default_value()
345338b8dc3SIngo Weinhold{
3460838a930SJérôme Duval	eval "$1=\${$1-$2}"
347338b8dc3SIngo Weinhold}
348338b8dc3SIngo Weinhold
349338b8dc3SIngo Weinhold# get_build_tool_path
350338b8dc3SIngo Weinhold#
351338b8dc3SIngo Weinhold# Gets a usable absolute path of a build tool.
352338b8dc3SIngo Weinhold#
353338b8dc3SIngo Weinholdget_build_tool_path()
354338b8dc3SIngo Weinhold{
355338b8dc3SIngo Weinhold	local var="HAIKU_$1"
356a7bddff1SJonathan Schleifer	local cmd=$2
357*d73993ffSAugustin Cavalier
358*d73993ffSAugustin Cavalier	if [ ! -z "${!var}" ]; then
359*d73993ffSAugustin Cavalier		# this variable is already set (probably by user) so grab its contents
360*d73993ffSAugustin Cavalier		cmd=${!var}
361*d73993ffSAugustin Cavalier	fi
362*d73993ffSAugustin Cavalier
363*d73993ffSAugustin Cavalier	local path=${cmd%% *}
364338b8dc3SIngo Weinhold
365338b8dc3SIngo Weinhold	if [ -f "$path" ]; then
366338b8dc3SIngo Weinhold		# get absolute path
367a559f87aSFrançois Revol		local oldPwd="`pwd`"
368a559f87aSFrançois Revol		cd "`dirname "$path"`"
369a559f87aSFrançois Revol		path="`pwd`/`basename "$path"`"
370338b8dc3SIngo Weinhold		cd $oldPwd
371338b8dc3SIngo Weinhold	else
3727fe2e06cSMatt Madia		which "$path" > /dev/null 2>&1 || {
373*d73993ffSAugustin Cavalier			echo "Build tool \"$path\" not found (maybe specify it in $var?)" >&2
374338b8dc3SIngo Weinhold			exit 1
375338b8dc3SIngo Weinhold		}
376338b8dc3SIngo Weinhold	fi
377338b8dc3SIngo Weinhold
378a7bddff1SJonathan Schleifer	eval "$var=\"$path ${cmd#${2%% *}}\""
379338b8dc3SIngo Weinhold}
380338b8dc3SIngo Weinhold
381483b28e4SIngo Weinholdis_in_list()
382483b28e4SIngo Weinhold{
383483b28e4SIngo Weinhold	local element
384483b28e4SIngo Weinhold	for element in $2; do
385483b28e4SIngo Weinhold		if [ "$1" = "$element" ]; then
386483b28e4SIngo Weinhold			return 0
387483b28e4SIngo Weinhold		fi
388483b28e4SIngo Weinhold	done
389483b28e4SIngo Weinhold	return 1
390483b28e4SIngo Weinhold}
391483b28e4SIngo Weinhold
3927f9beaf1SOliver Tappe# check for --help or -h and show usage immediately
3937f9beaf1SOliver Tappeif [ "$1" = "--help" ] || [ "$1" = "-h" ]; then
3948b420c2fSOliver Tappe	usage; exit 0;
3958b420c2fSOliver Tappefi
3968b420c2fSOliver Tappe
397c6c03d56SAugustin Cavalier# ensure umask is not too restrictive
398c6c03d56SAugustin Cavalierif [ $(umask) -gt 22 ]; then
399c6c03d56SAugustin Cavalier	echo "Your umask is too restrictive (should be: <= 0022; is actually:" $(umask)")"
400c6c03d56SAugustin Cavalier	exit 1
401c6c03d56SAugustin Cavalierfi
4028b420c2fSOliver Tappe
403338b8dc3SIngo Weinhold# get cwd and the source directory
404338b8dc3SIngo WeinholdcurrentDir=`pwd`
4056e7c6fe5SIngo Weinholdcd `dirname "$0"`
406338b8dc3SIngo WeinholdsourceDir=`pwd`
4076e7c6fe5SIngo Weinholdcd "$currentDir"
408338b8dc3SIngo Weinhold
40955d267a4SFrançois Revol# backup the passed arguments
41055d267a4SFrançois RevolconfigureArgs="$@"
41155d267a4SFrançois Revol
4127c4641d0SOliver Tappe# internal default parameter values
413022fa244SIngo Weinhold#
41452a38012Sejakowatzplatform=`uname`
4155abd9a46SIngo WeinholdplatformMachine=`uname  -m`
416c0e8cc1aSIngo WeinholdtargetArchs=
417338b8dc3SIngo WeinholdbuildCrossTools=
41829ef597dSIngo WeinholdbuildCrossToolsScript="$sourceDir/build/scripts/build_cross_tools"
41960d8d8fcSIngo WeinholdbuildCrossToolsJobs=
420c2b76f7fSJonathan SchleiferuseClang=0
421c0e8cc1aSIngo WeinholduseGccGraphiteDefault=0
422c0e8cc1aSIngo WeinholdunknownArchIndex=1
423483b28e4SIngo WeinholdhaikuTargetArchs=
4244da6cf84SFrançois RevolgdbSources=
4257c4641d0SOliver Tappe
42663701e7dSOliver Tappeif [ -z "$CC" ]; then
42763701e7dSOliver Tappe	CC=gcc
42863701e7dSOliver Tappefi
42963701e7dSOliver Tappe
4307c4641d0SOliver Tappe# exported (BuildSetup) default parameter values
4317c4641d0SOliver Tappe#
43263701e7dSOliver TappeHOST_GCC_RAW_VERSION=`$CC -dumpversion`
43363701e7dSOliver TappeHOST_GCC_MACHINE=`$CC -dumpmachine`
4347c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE=0
43576fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES=0
4367c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY=0
4377c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER=0
4387c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY=default
4397c4641d0SOliver TappeTARGET_PLATFORM=haiku
4407c4641d0SOliver TappeHAIKU_USE_GCC_PIPE=0
4417986925fSIngo WeinholdHAIKU_HOST_USE_32BIT=0
4427986925fSIngo WeinholdHAIKU_HOST_USE_XATTR=0
443bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF=0
4442ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY=0
445f04f7042SNiels Sascha ReedijkHOST_EXTENDED_REGEX_SED="sed -r"
44663701e7dSOliver TappeHOST_GCC_LD=`$CC -print-prog-name=ld`
44763701e7dSOliver TappeHOST_GCC_OBJCOPY=`$CC -print-prog-name=objcopy`
4482a5d0aafSIngo WeinholdHOST_SHA256=
449e173a1ecSIngo WeinholdHOST_HAIKU_PORTER=
450e173a1ecSIngo WeinholdHAIKU_PORTS=
451e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS=
452c9dd05ffSJonathan SchleiferHAIKU_IS_BOOTSTRAP=0
453e70c4c64SPulkoMandyHAIKU_BOOT_BOARD=
454aa2e5ecaSOliver TappeHAIKU_NO_DOWNLOADS=0
4552a5d0aafSIngo Weinhold
456c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS=
457c0e8cc1aSIngo Weinhold
458a04a520bSJonathan Schleiferset_default_value HAIKU_NASM		nasm
459c0e8cc1aSIngo Weinhold
4603942ca0dSIngo Weinholdif sha256sum < /dev/null > /dev/null 2>&1; then
4612a5d0aafSIngo Weinhold	HOST_SHA256=sha256sum
4623942ca0dSIngo Weinholdelif sha256 < /dev/null > /dev/null 2>&1; then
4632a5d0aafSIngo Weinhold	HOST_SHA256="sha256 -q"
464b5a871b1SNiels Sascha Reedijkelif shasum < /dev/null > /dev/null 2>&1; then
465b5a871b1SNiels Sascha Reedijk	HOST_SHA256="shasum -a 256"
4662a5d0aafSIngo Weinholdelse
4672a5d0aafSIngo Weinhold	echo "Error: Neither sha256sum nor sha256 seem to be available!" >&2
4682a5d0aafSIngo Weinhold	exit 1
4692a5d0aafSIngo Weinholdfi
470338b8dc3SIngo Weinhold
47184edb1a1SAxel DörflerhaikuRequiredLegacyGCCVersion="2.95.3-haiku-2017_07_20"
472a559f87aSFrançois Revolexport haikuRequiredLegacyGCCVersion
473af4bf973SOliver Tappe	# version of legacy gcc required to build haiku
474483b28e4SIngo WeinholdsupportedTargetArchs="
475483b28e4SIngo Weinhold	arm
476483b28e4SIngo Weinhold	m68k
477483b28e4SIngo Weinhold	ppc
478483b28e4SIngo Weinhold	x86
479483b28e4SIngo Weinhold	x86_64
480483b28e4SIngo Weinhold	x86_gcc2
481483b28e4SIngo Weinhold	"
482af4bf973SOliver Tappe
4837c4641d0SOliver Tappe# determine output directory
4847c4641d0SOliver Tappeif [ "$currentDir" = "$sourceDir" ]; then
4857c4641d0SOliver Tappe	outputDir=$currentDir/generated
4867c4641d0SOliver Tappeelse
4877c4641d0SOliver Tappe	outputDir=$currentDir
4887c4641d0SOliver Tappefi
4897c4641d0SOliver TappebuildOutputDir="$outputDir/build"
4907c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR="$outputDir/attributes"
4917c4641d0SOliver TappebuildConfigFile="$buildOutputDir/BuildConfig"
4927c4641d0SOliver Tappe
4937c4641d0SOliver Tappe# check for update request
4947c4641d0SOliver Tappeif [ "$1" = "--update" ]; then
4957c4641d0SOliver Tappe	if ! [ -e "$buildConfigFile" ]; then
4967c4641d0SOliver Tappe		echo $0 --update: \'$buildConfigFile\' not found - updating not possible.
4977c4641d0SOliver Tappe		exit 1
4987c4641d0SOliver Tappe	fi
4997c4641d0SOliver Tappe	if ! type perl >/dev/null 2>&1; then
5007c4641d0SOliver Tappe		echo $0 --update: \'perl\' not found - updating not possible.
5017c4641d0SOliver Tappe		exit 1
5027c4641d0SOliver Tappe	fi
5037c4641d0SOliver Tappe	# convert BuildConfig from jam format to shell format and evaluate it
5047c4641d0SOliver Tappe	shellConfigFile="${buildConfigFile}.shell"
5057c4641d0SOliver Tappe	perl "$sourceDir/build/scripts/convert_build_config_to_shell_format.pl" \
5067c4641d0SOliver Tappe		<"$buildConfigFile" >"$shellConfigFile"
5077c4641d0SOliver Tappe	. "$shellConfigFile"
5087c4641d0SOliver Tappe	rm "$shellConfigFile"
5097c4641d0SOliver Tappe	shift
5107c4641d0SOliver Tappefi
5117c4641d0SOliver Tappe
512022fa244SIngo Weinhold# parse parameters
513022fa244SIngo Weinhold#
51420ab75e6SIngo Weinholdwhile [ $# -gt 0 ] ; do
515022fa244SIngo Weinhold	case "$1" in
516e173a1ecSIngo Weinhold		--bootstrap)
517e173a1ecSIngo Weinhold			assertparams "$1" 3 $#
518e173a1ecSIngo Weinhold			HOST_HAIKU_PORTER="`absolute_path $2`"
519e173a1ecSIngo Weinhold			HAIKU_PORTS_CROSS="`absolute_path $3`"
520e173a1ecSIngo Weinhold			HAIKU_PORTS="`absolute_path $4`"
521c9dd05ffSJonathan Schleifer			HAIKU_IS_BOOTSTRAP=1
522c9dd05ffSJonathan Schleifer			HAIKU_NO_DOWNLOADS=1
523502882dbSJessica Hamilton			check_file_exists "$HOST_HAIKU_PORTER" || (
524502882dbSJessica Hamilton				echo "Invalid path to haikuporter: $HOST_HAIKU_PORTER" >&2
52539d444a3SArvind S Raj				exit 1
52639d444a3SArvind S Raj			)
52739d444a3SArvind S Raj			check_dir_exists "$HAIKU_PORTS" || (
52839d444a3SArvind S Raj				echo "Non-existent directory $HAIKU_PORTS" >&2
52939d444a3SArvind S Raj				exit 1
53039d444a3SArvind S Raj			)
53139d444a3SArvind S Raj			check_dir_exists "$HAIKU_PORTS_CROSS" || (
53239d444a3SArvind S Raj				echo "Non-existent directory $HAIKU_PORTS_CROSS" >&2
53339d444a3SArvind S Raj				exit 1
53439d444a3SArvind S Raj			)
535e173a1ecSIngo Weinhold			shift 4
536e173a1ecSIngo Weinhold			;;
537c0e8cc1aSIngo Weinhold		--build-cross-tools)
538c0e8cc1aSIngo Weinhold			if [ -z "$buildCrossTools" ]; then
5399b0dd528SIngo Weinhold				assertparams "$1" 2 $#
540c0e8cc1aSIngo Weinhold				targetArch=$2
5419b0dd528SIngo Weinhold				buildCrossTools=$3
5429b0dd528SIngo Weinhold				shift 3
543c0e8cc1aSIngo Weinhold			else
544c0e8cc1aSIngo Weinhold				assertparam "$1" $#
545c0e8cc1aSIngo Weinhold				targetArch=$2
546c0e8cc1aSIngo Weinhold				shift 2
547c0e8cc1aSIngo Weinhold			fi
548c0e8cc1aSIngo Weinhold			case "$targetArch" in
549c0e8cc1aSIngo Weinhold				x86_gcc2)	targetMachine=i586-pc-haiku;;
550c0e8cc1aSIngo Weinhold				x86)		targetMachine=i586-pc-haiku;;
551c0e8cc1aSIngo Weinhold				x86_64)		targetMachine=x86_64-unknown-haiku;;
552c0e8cc1aSIngo Weinhold				ppc)		targetMachine=powerpc-apple-haiku;;
553c0e8cc1aSIngo Weinhold				m68k)		targetMachine=m68k-unknown-haiku;;
554c0e8cc1aSIngo Weinhold				arm)		targetMachine=arm-unknown-haiku;;
555c0e8cc1aSIngo Weinhold				*)
556c0e8cc1aSIngo Weinhold					echo "Unsupported target architecture: $2" >&2
557c0e8cc1aSIngo Weinhold					exit 1
558c0e8cc1aSIngo Weinhold					;;
559c0e8cc1aSIngo Weinhold			esac
560c0e8cc1aSIngo Weinhold			set_variable buildCrossToolsMachine_$targetArch $targetMachine
561c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
562c0e8cc1aSIngo Weinhold			HAIKU_PACKAGING_ARCHS=
5639b0dd528SIngo Weinhold			;;
5649b0dd528SIngo Weinhold		--cross-tools-prefix)
5659b0dd528SIngo Weinhold			assertparam "$1" $#
566c0e8cc1aSIngo Weinhold			targetArch=unknown${unknownArchIndex}
567c0e8cc1aSIngo Weinhold			set_variable crossToolsPrefix_$targetArch "$2"
568c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
569c0e8cc1aSIngo Weinhold			HAIKU_PACKAGING_ARCHS=
570d68208faSMatt Madia			unknownArchIndex=$(($unknownArchIndex + 1))
5719b0dd528SIngo Weinhold			shift 2
5729b0dd528SIngo Weinhold			;;
573a66c32ddSIngo Weinhold		--distro-compatibility)
5749b0dd528SIngo Weinhold			assertparam "$1" $#
5757c4641d0SOliver Tappe			HAIKU_DISTRO_COMPATIBILITY=$2
5767c4641d0SOliver Tappe			case "$HAIKU_DISTRO_COMPATIBILITY" in
577a66c32ddSIngo Weinhold				official)	;;
578a66c32ddSIngo Weinhold				compatible)	;;
579a66c32ddSIngo Weinhold				default)	;;
580a66c32ddSIngo Weinhold				*)			echo "Invalid distro compatibility" \
5817c4641d0SOliver Tappe								"level: $HAIKU_DISTRO_COMPATIBILITY"
582a66c32ddSIngo Weinhold							exit 1;;
583a66c32ddSIngo Weinhold			esac
5849b0dd528SIngo Weinhold			shift 2
5859b0dd528SIngo Weinhold			;;
5867c4641d0SOliver Tappe		--enable-multiuser)	HAIKU_ENABLE_MULTIUSER=1; shift 1;;
5872ebcd86dSIngo Weinhold		--host-only)	HAIKU_HOST_BUILD_ONLY=1; shift 1;;
5887c4641d0SOliver Tappe		--include-patented-code)	HAIKU_INCLUDE_PATENTED_CODE=1; shift 1;;
58976fa0be3SIngo Weinhold		--include-sources)	HAIKU_INCLUDE_SOURCES=1; shift 1;;
5907c4641d0SOliver Tappe		--include-3rdparty)	HAIKU_INCLUDE_3RDPARTY=1; shift 1;;
59160d8d8fcSIngo Weinhold        -j*)				buildCrossToolsJobs="$1"; shift 1;;
592aa2e5ecaSOliver Tappe		--no-downloads)	HAIKU_NO_DOWNLOADS=1; shift 1;;
5937c4641d0SOliver Tappe		--target=*)     TARGET_PLATFORM=`echo $1 | cut -d'=' -f2-`; shift 1;;
594483b28e4SIngo Weinhold		--target-arch)
595483b28e4SIngo Weinhold			assertparam "$1" $#
596483b28e4SIngo Weinhold			targetArch=$2
597483b28e4SIngo Weinhold			shift 2
598483b28e4SIngo Weinhold			if [ ! "$platform" = Haiku ]; then
599483b28e4SIngo Weinhold				echo "--target-arch can only be specified on Haiku." >&2
600483b28e4SIngo Weinhold				exit 1
601483b28e4SIngo Weinhold			fi
602483b28e4SIngo Weinhold			is_in_list "$targetArch" "$supportedTargetArchs" || (
603483b28e4SIngo Weinhold				echo "Unsupported target architecture: \"$targetArch\"" >&2
604483b28e4SIngo Weinhold				exit 1
605483b28e4SIngo Weinhold			)
606483b28e4SIngo Weinhold			haikuTargetArchs="$haikuTargetArchs $targetArch"
607483b28e4SIngo Weinhold			;;
608*d73993ffSAugustin Cavalier		--use-clang)
609*d73993ffSAugustin Cavalier			assertparam "$1" $#
610*d73993ffSAugustin Cavalier			targetArch=$2
611*d73993ffSAugustin Cavalier			useClang=1
612*d73993ffSAugustin Cavalier			case "$targetArch" in
613*d73993ffSAugustin Cavalier				x86)		targetMachine=i586-pc-haiku;;
614*d73993ffSAugustin Cavalier				x86_64)		targetMachine=x86_64-unknown-haiku;;
615*d73993ffSAugustin Cavalier				*)
616*d73993ffSAugustin Cavalier					echo "Unsupported target architecture: $2" >&2
617*d73993ffSAugustin Cavalier					exit 1
618*d73993ffSAugustin Cavalier					;;
619*d73993ffSAugustin Cavalier			esac
620*d73993ffSAugustin Cavalier			targetArchs="$targetArchs $targetArch"
621*d73993ffSAugustin Cavalier			HAIKU_PACKAGING_ARCHS=
622*d73993ffSAugustin Cavalier			shift 2
623*d73993ffSAugustin Cavalier			;;
6247c4641d0SOliver Tappe		--use-gcc-pipe)	HAIKU_USE_GCC_PIPE=1; shift 1;;
625c0e8cc1aSIngo Weinhold		--use-gcc-graphite)	useGccGraphiteDefault=1; shift 1;;
6267986925fSIngo Weinhold		--use-32bit)	HAIKU_HOST_USE_32BIT=1; shift 1;;
6277986925fSIngo Weinhold		--use-xattr)	HAIKU_HOST_USE_XATTR=1; shift 1;;
628bc96e8f3SIngo Weinhold		--use-xattr-ref)	HAIKU_HOST_USE_XATTR_REF=1; shift 1;;
6294da6cf84SFrançois Revol		--with-gdb)	gdbSources=$2; shift 2;;
630022fa244SIngo Weinhold		*)				echo Invalid argument: \`$1\'; exit 1;;
631022fa244SIngo Weinhold	esac
632022fa244SIngo Weinholddone
633022fa244SIngo Weinhold
6340df3cc9cSIngo Weinhold# detect the build platform
635338b8dc3SIngo Weinholdcase "${platform}" in
6367c4641d0SOliver Tappe	Darwin)	HOST_PLATFORM=darwin ;;
6377c4641d0SOliver Tappe	FreeBSD)	HOST_PLATFORM=freebsd
6387986925fSIngo Weinhold				if [ "$HAIKU_HOST_USE_32BIT" = 1 ] ; then
6395abd9a46SIngo Weinhold					echo Unsupported platform: FreeBSD ${platformMachine}
640308c212cSIngo Weinhold					exit 1
641308c212cSIngo Weinhold				fi	;;
6427c4641d0SOliver Tappe	Haiku)	HOST_PLATFORM=haiku_host ;;
6437c4641d0SOliver Tappe	Linux)	HOST_PLATFORM=linux ;;
6447c4641d0SOliver Tappe	OpenBSD) HOST_PLATFORM=openbsd ;;
6457c4641d0SOliver Tappe	SunOS)	HOST_PLATFORM=sunos ;;
6467c4641d0SOliver Tappe	CYGWIN_NT-*) HOST_PLATFORM=cygwin ;;
647338b8dc3SIngo Weinhold	*)		echo Unsupported platform: ${platform}
6484cbe4925SAxel Dörfler			exit 1 ;;
6494cbe4925SAxel Dörfleresac
65052a38012Sejakowatz
6510962132cSAlex Smith# check for case-sensitive filesystem
6520962132cSAlex Smithmkdir haikuCaseTest 2>/dev/null
6530962132cSAlex Smithmkdir haikucasetest 2>/dev/null
6540962132cSAlex SmithcaseInsensitive=$?
65597f5a0bdSAlex Smithrmdir haikuCaseTest haikucasetest 2>/dev/null
6560962132cSAlex Smithif [ $caseInsensitive != 0 ]; then
6573ecc5287SMichael Lotz	echo "You need a case-sensitive file-system to build Haiku."
6580962132cSAlex Smith	if [ $HOST_PLATFORM = "darwin" ]; then
6597a05e252SJohn Scipione		echo "You can create a case-sensitive disk image using Disk Utility."
6603ecc5287SMichael Lotz	fi
6610962132cSAlex Smith	exit 1
6623ecc5287SMichael Lotzfi
6633ecc5287SMichael Lotz
664f04f7042SNiels Sascha Reedijk# determine how to invoke sed with extended regexp support for non-GNU sed
665f04f7042SNiels Sascha Reedijkif [ $HOST_PLATFORM = "darwin" ]; then
666f04f7042SNiels Sascha Reedijk	HOST_EXTENDED_REGEX_SED="sed -E"
667f04f7042SNiels Sascha Reedijkfi
668f04f7042SNiels Sascha Reedijk
669cb721c59SFrançois Revol# check if nasm can actually output ELF files
670cb721c59SFrançois Revol# (the stock version in OSX can't)
671cb721c59SFrançois Revol# XXX: should probably only test for x86* arch
6723e6c09cdSAdrien Destuguesif [ "$("$HAIKU_NASM" -hf | grep -c elf'[36][24] ')" -ne "2" ]; then
673cb721c59SFrançois Revol	echo "$HAIKU_NASM cannot generate ELF files. Please install a working version."
674cb721c59SFrançois Revol	if [ $HOST_PLATFORM = "darwin" ]; then
675cb721c59SFrançois Revol		echo "You can install it from Mac Ports."
676cb721c59SFrançois Revol		echo "Mac Ports is available at: http://www.macports.org/"
677cb721c59SFrançois Revol	fi
678cb721c59SFrançois Revol	exit 1
679cb721c59SFrançois Revolfi
680cb721c59SFrançois Revol
681338b8dc3SIngo Weinhold# create output directory
6826e7c6fe5SIngo Weinholdmkdir -p "$buildOutputDir" || exit 1
683338b8dc3SIngo Weinhold
6842ebcd86dSIngo Weinholdif [ "$HAIKU_HOST_BUILD_ONLY" = 1 ]; then
6852ebcd86dSIngo Weinhold	invalidCommand=$sourceDir/build/scripts/host_build_only
6862ebcd86dSIngo Weinhold	HAIKU_AR=$invalidCommand
6872ebcd86dSIngo Weinhold	HAIKU_CC=$invalidCommand
6882ebcd86dSIngo Weinhold	HAIKU_LD=$invalidCommand
6892ebcd86dSIngo Weinhold	HAIKU_OBJCOPY=$invalidCommand
6902ebcd86dSIngo Weinhold	HAIKU_RANLIB=$invalidCommand
6912ebcd86dSIngo Weinhold	HAIKU_ELFEDIT=$invalidCommand
692d6f80927SJonathan Schleifer	HAIKU_NASM=$invalidCommand
6932ebcd86dSIngo Weinhold	HAIKU_STRIP=$invalidCommand
6942ebcd86dSIngo Weinholdelse
695c0e8cc1aSIngo Weinhold	if [ -n "$HAIKU_PACKAGING_ARCHS" ]; then
696c0e8cc1aSIngo Weinhold		targetArchs="$HAIKU_PACKAGING_ARCHS"
697c0e8cc1aSIngo Weinhold	fi
698c0e8cc1aSIngo Weinhold	HAIKU_PACKAGING_ARCHS=
699c0e8cc1aSIngo Weinhold
700483b28e4SIngo Weinhold	# On Haiku determine target architectures and tools automatically.
701c0e8cc1aSIngo Weinhold	if [ -z "$targetArchs" ]; then
702483b28e4SIngo Weinhold		if [ $HOST_PLATFORM != haiku_host ]; then
703483b28e4SIngo Weinhold			echo "Please specify the build tools to use or build (via" \
704eaef83a9SJeroen Oortwijn				"--cross-tools-prefix or --build-cross-tools) or specify a" \
705483b28e4SIngo Weinhold				"host-only build (--host-only)." >&2
7067f9beaf1SOliver Tappe			echo "For more info, invoke $0 --help"
707483b28e4SIngo Weinhold			exit 1
708483b28e4SIngo Weinhold		fi
709483b28e4SIngo Weinhold
710483b28e4SIngo Weinhold		# determine primary architecture
711dda53eaeSIngo Weinhold		targetArch=`package list -i /system/packages/haiku-*.hpkg \
712483b28e4SIngo Weinhold			| sed '/^\s*architecture:/!d; s,^\s*architecture:\s*,,'`
713483b28e4SIngo Weinhold		is_in_list "$targetArch" "$supportedTargetArchs" || (
714483b28e4SIngo Weinhold			echo "Unsupported target architecture: \"$targetArch\"" >&2
715483b28e4SIngo Weinhold			exit 1
716483b28e4SIngo Weinhold		)
717c0e8cc1aSIngo Weinhold		targetArchs=$targetArch
718483b28e4SIngo Weinhold
719c0e8cc1aSIngo Weinhold		set_default_value HAIKU_AR_$targetArch			ar
720c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CC_$targetArch			gcc
721c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LD_$targetArch			ld
722c0e8cc1aSIngo Weinhold		set_default_value HAIKU_OBJCOPY_$targetArch		objcopy
723c0e8cc1aSIngo Weinhold		set_default_value HAIKU_RANLIB_$targetArch		ranlib
724c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ELFEDIT_$targetArch		elfedit
725c0e8cc1aSIngo Weinhold		set_default_value HAIKU_STRIP_$targetArch		strip
726483b28e4SIngo Weinhold
727483b28e4SIngo Weinhold		# determine secondary architectures
728483b28e4SIngo Weinhold		for targetArch in $supportedTargetArchs; do
72980262a91SMatt Madia			if [ -e /system/packages/haiku_$targetArch-*.hpkg ]; then
730483b28e4SIngo Weinhold				targetArchs="$targetArchs $targetArch"
731483b28e4SIngo Weinhold				set_default_value HAIKU_AR_$targetArch		ar-$targetArch
732483b28e4SIngo Weinhold				set_default_value HAIKU_CC_$targetArch		gcc-$targetArch
733483b28e4SIngo Weinhold				set_default_value HAIKU_LD_$targetArch		ld-$targetArch
734483b28e4SIngo Weinhold				set_default_value HAIKU_OBJCOPY_$targetArch	objcopy-$targetArch
735483b28e4SIngo Weinhold				set_default_value HAIKU_RANLIB_$targetArch	ranlib-$targetArch
736483b28e4SIngo Weinhold				set_default_value HAIKU_ELFEDIT_$targetArch	elfedit-$targetArch
737483b28e4SIngo Weinhold				set_default_value HAIKU_STRIP_$targetArch	strip-$targetArch
738483b28e4SIngo Weinhold			fi
739483b28e4SIngo Weinhold		done
740483b28e4SIngo Weinhold
741483b28e4SIngo Weinhold		# The target architectures might have been specified explicitly.
742483b28e4SIngo Weinhold		if [ -n "$haikuTargetArchs" ]; then
743483b28e4SIngo Weinhold			for targetArch in $haikuTargetArchs; do
744483b28e4SIngo Weinhold				is_in_list "$targetArch" "$targetArchs" || (
745483b28e4SIngo Weinhold					echo "Unsupported target architecture: \"$targetArch\"." \
746483b28e4SIngo Weinhold						"Only native architectures of the host platform can" \
747483b28e4SIngo Weinhold						"be specified." >&2
748483b28e4SIngo Weinhold					exit 1
749483b28e4SIngo Weinhold				)
750483b28e4SIngo Weinhold			done
751483b28e4SIngo Weinhold			targetArchs="$haikuTargetArchs"
752483b28e4SIngo Weinhold		fi
753c0e8cc1aSIngo Weinhold	fi
754c0e8cc1aSIngo Weinhold
75568ccc989SIngo Weinhold	isPrimaryArch=1
756c0e8cc1aSIngo Weinhold	for targetArch in $targetArchs; do
757c0e8cc1aSIngo Weinhold		# Note: targetArch is "unknown<n>" at this point, if a cross-tools
758c0e8cc1aSIngo Weinhold		# prefix was specified. The standard_gcc_settings call below will get
759c0e8cc1aSIngo Weinhold		# the actual architecture.
760c0e8cc1aSIngo Weinhold
761c0e8cc1aSIngo Weinhold		crossToolsPrefix=`get_variable crossToolsPrefix_$targetArch`
762c0e8cc1aSIngo Weinhold
763338b8dc3SIngo Weinhold		# build cross tools from sources
764c0e8cc1aSIngo Weinhold		if [ -n "$buildCrossTools" -a -z "$crossToolsPrefix" ]; then
765c0e8cc1aSIngo Weinhold			crossToolsDir="$outputDir/cross-tools-$targetArch"
766c0e8cc1aSIngo Weinhold			targetMachine=`get_variable buildCrossToolsMachine_$targetArch`
767c0e8cc1aSIngo Weinhold			script="$buildCrossToolsScript"
7688304ec7cSIngo Weinhold			scriptArgs=
769c0e8cc1aSIngo Weinhold			if [ $targetArch != x86_gcc2 ]; then
7708304ec7cSIngo Weinhold				script="${script}_gcc4"
7718304ec7cSIngo Weinhold				scriptArgs="$targetMachine"
7721e93288eSJérôme Duval				set_default_value HAIKU_USE_GCC_GRAPHITE_$targetArch	\
7731e93288eSJérôme Duval					$useGccGraphiteDefault
774c0e8cc1aSIngo Weinhold			fi
77568ccc989SIngo Weinhold			secondaryArch=
77668ccc989SIngo Weinhold			if [ -z "$isPrimaryArch" ]; then
77768ccc989SIngo Weinhold				secondaryArch=$targetArch
77868ccc989SIngo Weinhold			fi
77986de8c37SIngo Weinhold
78086de8c37SIngo Weinhold			case $HOST_PLATFORM in
78186de8c37SIngo Weinhold				freebsd|openbsd)	MAKE=gmake;;
78286de8c37SIngo Weinhold				*)					MAKE=make;;
78386de8c37SIngo Weinhold			esac
78486de8c37SIngo Weinhold
78586de8c37SIngo Weinhold			MAKE=$MAKE \
78668ccc989SIngo Weinhold			SECONDARY_ARCH=$secondaryArch \
787c0e8cc1aSIngo Weinhold			HAIKU_USE_GCC_GRAPHITE=`get_variable \
788c0e8cc1aSIngo Weinhold				HAIKU_USE_GCC_GRAPHITE_$targetArch` \
789b3ece905SJérôme Duval			HAIKU_USE_GCC_PIPE=$HAIKU_USE_GCC_PIPE \
7904da6cf84SFrançois Revol			HAIKU_USE_GDB="$gdbSources" \
7918304ec7cSIngo Weinhold			"$script" $scriptArgs "$sourceDir" "$buildCrossTools" \
7928304ec7cSIngo Weinhold				"$crossToolsDir" $buildCrossToolsJobs || exit 1
793c0e8cc1aSIngo Weinhold			crossToolsPrefix="$crossToolsDir/bin/${targetMachine}-"
794338b8dc3SIngo Weinhold		fi
795338b8dc3SIngo Weinhold
796c0e8cc1aSIngo Weinhold		# prepare gcc settings and get the actual target architecture
797a7bddff1SJonathan Schleifer		if [ $useClang = 1 ]; then
798*d73993ffSAugustin Cavalier			gcc="clang -target ${targetMachine} -no-integrated-as"
799*d73993ffSAugustin Cavalier		elif [ -z "${crossToolsPrefix}" ]; then
800*d73993ffSAugustin Cavalier			gcc=`get_variable HAIKU_CC_$targetArch`
801a7bddff1SJonathan Schleifer		else
802c0e8cc1aSIngo Weinhold			gcc="${crossToolsPrefix}gcc"
803a7bddff1SJonathan Schleifer		fi
804c0e8cc1aSIngo Weinhold		standard_gcc_settings "$gcc"
805c0e8cc1aSIngo Weinhold		targetArch=$standard_gcc_settings_targetArch
806338b8dc3SIngo Weinhold
807c0e8cc1aSIngo Weinhold		# set default values for flags
808c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CPPFLAGS_$targetArch	""
809c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CCFLAGS_$targetArch		""
810c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CXXFLAGS_$targetArch	""
811c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LDFLAGS_$targetArch		""
812c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ARFLAGS_$targetArch		cru
813c0e8cc1aSIngo Weinhold		set_default_value HAIKU_UNARFLAGS_$targetArch	x
814338b8dc3SIngo Weinhold
815c0e8cc1aSIngo Weinhold		# Override the cross tools variables, if the tools were built or a
816c0e8cc1aSIngo Weinhold		# prefix was specified.
817b7777272SAlex Smith		if [ -n "$crossToolsPrefix" ]; then
818c0e8cc1aSIngo Weinhold			get_build_tool_path AR_$targetArch ${crossToolsPrefix}ar
819c0e8cc1aSIngo Weinhold			get_build_tool_path LD_$targetArch ${crossToolsPrefix}ld
820c0e8cc1aSIngo Weinhold			get_build_tool_path OBJCOPY_$targetArch ${crossToolsPrefix}objcopy
821c0e8cc1aSIngo Weinhold			get_build_tool_path RANLIB_$targetArch ${crossToolsPrefix}ranlib
822c0e8cc1aSIngo Weinhold			get_build_tool_path STRIP_$targetArch ${crossToolsPrefix}strip
823c0e8cc1aSIngo Weinhold
824c0e8cc1aSIngo Weinhold			case `get_variable HAIKU_GCC_RAW_VERSION_$targetArch` in
825133e4131SJérôme Duval				4.*|5.*|6.*|7.*|8.*)
826c0e8cc1aSIngo Weinhold					get_build_tool_path ELFEDIT_$targetArch \
827c0e8cc1aSIngo Weinhold						${crossToolsPrefix}elfedit
828bd16f0ddSAlex Smith				;;
829bd16f0ddSAlex Smith			esac
83052a38012Sejakowatz		fi
83152a38012Sejakowatz
832ef57df3dSIngo Weinhold		# check whether the Haiku compiler really targets Haiku
833c0e8cc1aSIngo Weinhold		targetMachine=`get_variable HAIKU_GCC_MACHINE_$targetArch`
834c0e8cc1aSIngo Weinhold		case "$targetMachine" in
835eedc3d0bSIngo Weinhold			*-*-haiku)	;;
836c0e8cc1aSIngo Weinhold			*)
837c0e8cc1aSIngo Weinhold				echo The compiler specified as Haiku target compiler is not a \
838c0e8cc1aSIngo Weinhold				valid Haiku cross-compiler. Please see ReadMe.cross-compile. >&2
839eedc3d0bSIngo Weinhold				echo compiler: $HAIKU_CC
840c0e8cc1aSIngo Weinhold				echo compiler is configured for target: $targetMachine
841eedc3d0bSIngo Weinhold				exit 1 ;;
842eedc3d0bSIngo Weinhold		esac
843c0e8cc1aSIngo Weinhold
844c0e8cc1aSIngo Weinhold		HAIKU_PACKAGING_ARCHS="$HAIKU_PACKAGING_ARCHS $targetArch"
84568ccc989SIngo Weinhold		isPrimaryArch=
846c0e8cc1aSIngo Weinhold	done
8472ebcd86dSIngo Weinholdfi
848eedc3d0bSIngo Weinhold
84952a38012Sejakowatz# Generate BuildConfig
8507c4641d0SOliver Tappecat << EOF > "$buildConfigFile"
85152a38012Sejakowatz# BuildConfig
852ab2540c4SIngo Weinhold# Note: This file has been automatically generated by configure with the
853ab2540c4SIngo Weinhold# following arguments:
85455d267a4SFrançois Revol# ${configureArgs}
85552a38012Sejakowatz
8567c4641d0SOliver TappeTARGET_PLATFORM 			?= "${TARGET_PLATFORM}" ;
8577c4641d0SOliver TappeHOST_PLATFORM				?= "${HOST_PLATFORM}" ;
858338b8dc3SIngo Weinhold
8597c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE			?= "${HAIKU_INCLUDE_PATENTED_CODE}" ;
86076fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES				?= "${HAIKU_INCLUDE_SOURCES}" ;
8617c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY				?= "${HAIKU_INCLUDE_3RDPARTY}" ;
8627c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER				?= "${HAIKU_ENABLE_MULTIUSER}" ;
8637c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY			?= "${HAIKU_DISTRO_COMPATIBILITY}" ;
8647c4641d0SOliver TappeHAIKU_USE_GCC_PIPE					?= "${HAIKU_USE_GCC_PIPE}" ;
8657986925fSIngo WeinholdHAIKU_HOST_USE_32BIT				?= "${HAIKU_HOST_USE_32BIT}" ;
8667986925fSIngo WeinholdHAIKU_HOST_USE_XATTR				?= "${HAIKU_HOST_USE_XATTR}" ;
867bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF			?= "${HAIKU_HOST_USE_XATTR_REF}" ;
8682ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY				?= "${HAIKU_HOST_BUILD_ONLY}" ;
869eccc7665SIngo Weinhold
870c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS		?= ${HAIKU_PACKAGING_ARCHS} ;
87165ad1ba3SAlex Smith
872aa2e5ecaSOliver TappeHAIKU_NO_DOWNLOADS			?= "${HAIKU_NO_DOWNLOADS}" ;
873aa2e5ecaSOliver Tappe
8747c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR	?= ${HAIKU_BUILD_ATTRIBUTES_DIR} ;
875338b8dc3SIngo Weinhold
876d6f80927SJonathan SchleiferHAIKU_NASM					?= ${HAIKU_NASM} ;
877e70c4c64SPulkoMandyHAIKU_BOOT_BOARD			?= ${HAIKU_BOOT_BOARD} ;
878338b8dc3SIngo Weinhold
879f04f7042SNiels Sascha ReedijkHOST_EXTENDED_REGEX_SED		?= ${HOST_EXTENDED_REGEX_SED} ;
8807c4641d0SOliver TappeHOST_GCC_RAW_VERSION		?= ${HOST_GCC_RAW_VERSION} ;
8817c4641d0SOliver TappeHOST_GCC_MACHINE			?= ${HOST_GCC_MACHINE} ;
8827c4641d0SOliver TappeHOST_LD						?= ${HOST_GCC_LD} ;
8837c4641d0SOliver TappeHOST_OBJCOPY				?= ${HOST_GCC_OBJCOPY} ;
8842a5d0aafSIngo WeinholdHOST_SHA256					?= ${HOST_SHA256} ;
8858b5934c9SIngo Weinhold
886e173a1ecSIngo WeinholdHOST_HAIKU_PORTER			?= ${HOST_HAIKU_PORTER} ;
887e173a1ecSIngo WeinholdHAIKU_PORTS					?= ${HAIKU_PORTS} ;
888e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS			?= ${HAIKU_PORTS_CROSS} ;
889c9dd05ffSJonathan SchleiferHAIKU_IS_BOOTSTRAP			?= ${HAIKU_IS_BOOTSTRAP} ;
890e173a1ecSIngo Weinhold
891c4786ea6SlilloEOF
892c4786ea6Slillo
893c0e8cc1aSIngo Weinholdfor targetArch in $HAIKU_PACKAGING_ARCHS; do
894c0e8cc1aSIngo Weinhold	variables="
895c0e8cc1aSIngo Weinhold		HAIKU_GCC_RAW_VERSION		HAIKU_GCC_RAW_VERSION
896c0e8cc1aSIngo Weinhold		HAIKU_GCC_MACHINE			HAIKU_GCC_MACHINE
897c0e8cc1aSIngo Weinhold		HAIKU_GCC_LIB_DIR			HAIKU_GCC_LIB_DIR
898c0e8cc1aSIngo Weinhold		HAIKU_CPU					HAIKU_CPU
899c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBGCC			HAIKU_BOOT_LIBGCC
900c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBSUPC++		HAIKU_BOOT_LIBSUPCXX
901c0e8cc1aSIngo Weinhold		HAIKU_AR					HAIKU_AR
902c0e8cc1aSIngo Weinhold		HAIKU_CC					HAIKU_CC
903c2b76f7fSJonathan Schleifer		HAIKU_CC_IS_CLANG			HAIKU_CC_IS_CLANG
904c0e8cc1aSIngo Weinhold		HAIKU_LD					HAIKU_LD
905c0e8cc1aSIngo Weinhold		HAIKU_OBJCOPY				HAIKU_OBJCOPY
906c0e8cc1aSIngo Weinhold		HAIKU_RANLIB				HAIKU_RANLIB
907c0e8cc1aSIngo Weinhold		HAIKU_ELFEDIT				HAIKU_ELFEDIT
908c0e8cc1aSIngo Weinhold		HAIKU_STRIP					HAIKU_STRIP
909c0e8cc1aSIngo Weinhold		HAIKU_CPPFLAGS				HAIKU_CPPFLAGS
910c0e8cc1aSIngo Weinhold		HAIKU_CCFLAGS				HAIKU_CCFLAGS
911c0e8cc1aSIngo Weinhold		HAIKU_C++FLAGS				HAIKU_CXXFLAGS
912c0e8cc1aSIngo Weinhold		HAIKU_LDFLAGS				HAIKU_LDFLAGS
913c0e8cc1aSIngo Weinhold		HAIKU_ARFLAGS				HAIKU_ARFLAGS
914c0e8cc1aSIngo Weinhold		HAIKU_UNARFLAGS				HAIKU_UNARFLAGS
915c0e8cc1aSIngo Weinhold		HAIKU_USE_GCC_GRAPHITE		HAIKU_USE_GCC_GRAPHITE
916c0e8cc1aSIngo Weinhold		"
917c0e8cc1aSIngo Weinhold	set -- $variables
918c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
919c0e8cc1aSIngo Weinhold		value=`get_variable ${2}_$targetArch`
920c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= $value ;" >> "$buildConfigFile"
921c0e8cc1aSIngo Weinhold		shift 2
922c0e8cc1aSIngo Weinhold	done
923b1e5b60cSAxel Dörfler
924c0e8cc1aSIngo Weinhold	# For variables that may have long values, distribute them over multiple
925c0e8cc1aSIngo Weinhold	# lines so that jam doesn't hit the maximum line length.
926c0e8cc1aSIngo Weinhold	variables="
92766a7f29fSJérôme Duval		HAIKU_BOOT_C++_HEADERS_DIR	HAIKU_BOOT_CXX_HEADERS_DIR
928c0e8cc1aSIngo Weinhold		"
929c0e8cc1aSIngo Weinhold	set -- $variables
930c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
931c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= " >> "$buildConfigFile"
932c0e8cc1aSIngo Weinhold		get_variable ${2}_$targetArch | xargs -n 1 echo "   " \
933c0e8cc1aSIngo Weinhold			>> "$buildConfigFile"
934c0e8cc1aSIngo Weinhold		echo "    ;" >> "$buildConfigFile"
935c0e8cc1aSIngo Weinhold		shift 2
936c0e8cc1aSIngo Weinhold	done
937c0e8cc1aSIngo Weinholddone
938b1e5b60cSAxel Dörfler
939b1e5b60cSAxel Dörfler
9409b0dd528SIngo Weinhold# Generate a boot strap Jamfile in the output directory.
941338b8dc3SIngo Weinhold
942338b8dc3SIngo Weinholdcat << EOF > $outputDir/Jamfile
943338b8dc3SIngo Weinhold# automatically generated Jamfile
944338b8dc3SIngo Weinhold
945338b8dc3SIngo WeinholdHAIKU_TOP			= ${sourceDir} ;
946338b8dc3SIngo WeinholdHAIKU_OUTPUT_DIR	= ${outputDir} ;
947338b8dc3SIngo Weinhold
948338b8dc3SIngo Weinholdinclude [ FDirName \$(HAIKU_TOP) Jamfile ] ;
949338b8dc3SIngo Weinhold
950338b8dc3SIngo WeinholdEOF
951*d73993ffSAugustin Cavalier
952*d73993ffSAugustin Cavalierecho "Configured successfully!"
953